/** (C) 2002 Peter Stevens
 * This is licensed under the GNU GPL
 *
 * See the file copying for details
 */


/** Scores */
typedef struct {
	Int16 value;
	Int16 result;
} Score;

typedef struct {
	Int16 (* scorefunction)(Int16 dice[]);
	Int16 (* rerollfunction)(Int16 dice[], Int16 reroll[]);
	Int16 expected;
} ScoreDefinition;

ScoreDefinition scoredefinition[13];

typedef struct scoresheet * ScoreSheetPtr;
typedef struct scoresheet {

	char name[13];
	Int16 number;
	
	Score score[13];
	Int16 bonus;
	Int16 total;

	Int16 playertype;
} ScoreSheet;


/** Functions for calculating scores
 * */


Int16 setScore(Int16 objId, Int16 (*FnPtr)(Int16 dice[]));


/** 0 = Score Allocated
 *  -1 = Score Not Allocated
 *  */
Int16 score(Int16 ControlId, ScoreSheetPtr s);

Int16 aggregateScore(Int16 ControlId, Int16(*FnPtr)(ScoreSheetPtr s), ScoreSheetPtr s);
void * getValues();
Int16 ones(Int16 dice[]);
Int16 twos(Int16 dice[]);
Int16 threes(Int16 dice[]);
Int16 fours(Int16 dice[]);
Int16 fives(Int16 dice[]);
Int16 sixes(Int16 dice[]);
Int16 threeofakind(Int16 dice[]);
Int16 fourofakind(Int16 dice[]);
Int16 fullhouse(Int16 dice[]);
Int16 shortstraight(Int16 dice[]);
Int16 longstraight(Int16 dice[]);
Int16 yahtzee(Int16 dice[]);
Int16 chance(Int16 dice[]);
Int16 bonus(ScoreSheetPtr score);
Int16 total(ScoreSheetPtr score);
Int16 lowerTotal(ScoreSheetPtr score);
Int16 upperTotal(ScoreSheetPtr score);

Int16 trueValue(Int16 q);



// Functions to manage sheets
ScoreSheetPtr InitScoreSheet(char [], UInt16 playertype);
void DestroyScoreSheet();
void defineSheet(ScoreDefinition scoredefinition[]);
void handleScore(UInt16 control);
void drawScoreBoard (ScoreSheetPtr scr);

extern ScoreSheetPtr scores[6];
